CREATE TABLE vessel_behavior (
    vessel_behavior_id SMALLINT PRIMARY KEY,
    vessel_behavior_name TEXT UNIQUE NOT NULL
);
INSERT INTO vessel_behavior (vessel_behavior_id, vessel_behavior_name) VALUES (0, 'Unknown');
INSERT INTO vessel_behavior (vessel_behavior_id, vessel_behavior_name) VALUES (1, 'Docked');
INSERT INTO vessel_behavior (vessel_behavior_id, vessel_behavior_name) VALUES (2, 'Fishing');
INSERT INTO vessel_behavior (vessel_behavior_id, vessel_behavior_name) VALUES (3, 'Travel');
INSERT INTO vessel_behavior (vessel_behavior_id, vessel_behavior_name) VALUES (4, 'Poling');
CREATE TABLE vessel_path
(
    vessel_path_id serial NOT NULL,
    vessel_id integer NOT NULL,
    vessel_path_start TIMESTAMP NOT NULL,
    CONSTRAINT vessel_path_pkey PRIMARY KEY (vessel_path_id),
    CONSTRAINT vessel_path_vessel_id_vessel_path_start_key UNIQUE (vessel_id, vessel_path_start)
);
CREATE TABLE vessel_point(
    vessel_point_id SERIAL,
    vessel_path_id integer REFERENCES vessel_path (vessel_path_id),
    point_timestamp TIMESTAMP WITHOUT TIME ZONE NOT NULL,
    duration_in_seconds smallint NOT NULL,
    speed numeric(8,6) NOT NULL,
    net_speed numeric(8,6) NOT NULL,
	movement_angle numeric(9,6) NOT NULL,
    vessel_behavior_id integer REFERENCES vessel_behavior (vessel_behavior_id),
    CONSTRAINT vessel_point_duration_in_seconds_check CHECK (duration_in_seconds BETWEEN 1 AND 1200)
);
SELECT AddGeometryColumn('vessel_point', 'coords', 4269, 'POINT', 2);
